// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package gost

import (
	"go.cypherpunks.su/gogost/v6/gost3410"
)

const (
	GOST3410256A       = "gost3410-256A"
	GOST3410512C       = "gost3410-512C"
	GOST3410256AMerkle = "gost3410-256A-merkle"
	GOST3410512CMerkle = "gost3410-512C-merkle"
)

func CurveByName(name string) (curve *gost3410.Curve) {
	switch name {
	case GOST3410256A:
		curve = gost3410.CurveIdtc26gost341012256paramSetA()
	case GOST3410512C:
		curve = gost3410.CurveIdtc26gost341012512paramSetC()
	}
	return
}
